# 部署 letsencrypt

- 为域名 x1.xx.com 和 x2.xx.com 申请 ssl 证书，并在每月的 31 号晚上十一点更新一次
- 为域名 \*.xxx.com 申请 ssl 证书，并在每月的 31 号晚上十点更新一次
- 根据实际环境修改
    - docker-compose.yml

- 创建目录
    ```
    grep '\<source:' docker-compose.yml | cut -d: -f2 | xargs mkdir -p
    ```

- 获取通配域名的证书时，需要手动设置 TXT 解析记录，这里配合脚本实现自动化获取和更新
    - 调用腾讯云接口设置 TXT 解析记录
        ```
        cp tencent-api.sh letsencrypt-wildcard/etc/manual-hook.sh
        ```

    - 调用腾讯云接口设置 TXT 解析记录
        ```
        cp aliyun-api.sh letsencrypt-wildcard/etc/manual-hook.sh
        ```


- 启动
    ```
    docker-compose up -d
    ```

- 创建定时任务
    ```
    0 23 31 * * docker-compose -f /compose/docker-compose.yml up -d letsencrypt
    0 22 31 * * docker-compose -f /compose/docker-compose.yml up -d letsencrypt-wildcard
    ```

