# 构建 redis 镜像

## 定制
- 安装 redis
- 固定一些常用配置
- __主节点数量最少三个，从节点要么没有，要么与主节点数量一致，否则出错__
- docker 参数: --privileged

## 外挂目录和文件
- /var/lib/redis: redis 数据目录
- /var/log/redis: redis 日志目录

## 引入环境变量
- MASTER_NODES: 主节点列表，__用空格间隔__
- SLAVE_NODES: 从节点列表，__用空格间隔__
- \_CONF\_\*: redis 配置

## 案例
- [Demo/SingleNode/](Demo/SingleNode/): 部署单点
- [Demo/ThreeNodes/](Demo/ThreeNodes/): 部署集群，只有三个主节点
- [Demo/SixNodes/](Demo/SixNodes/): 部署集群，有三个主节点和三个从节点

